//---------------------------------------------------------------------------

#ifndef MainFrmH
#define MainFrmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#include <tchar.h>
//---------------------------------------------------------------------------
#define DLLEXPORT __declspec(dllimport)
//---------------------------------------------------------------------------
#define WM_MY_LBUTTONDOWN (WM_APP + 1)
#define WM_MY_MBUTTONDOWN (WM_APP + 2)
#define WM_MY_RBUTTONDOWN (WM_APP + 3)
#define WM_MY_MOUSEMOVE   (WM_APP + 4)
#define WM_MY_KEYDOWN     (WM_APP + 10)
#define WM_MY_TASKTRAY    (WM_APP + 20)
//---------------------------------------------------------------------------
// Lp\
typedef struct
{
    HWND hWnd;
} SHARED_DATA;
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
private:
__published:    // IDE Ǘ̃R|[lg
    TTimer *Timer1;
    TLabel *SecondLabel;
    TEdit *MaxSecondEdit;
    TUpDown *MaxSecondUpDown;
    TPopupMenu *PopupMenu1;
    TMenuItem *ExitItem;
    TButton *MinimizeButton;
    TMenuItem *ShowItem;
    TMenuItem *N2;
    TButton *StartStopButton;
    TTimer *Timer2;
    TButton *ExitButton;
    TMenuItem *MinimizeItem;
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall MaxSecondUpDownChangingEx(TObject *Sender, bool &AllowChange, short NewValue,
          TUpDownDirection Direction);
    void __fastcall MaxSecondEditChange(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall ExitItemClick(TObject *Sender);
    void __fastcall MinimizeButtonClick(TObject *Sender);
    void __fastcall ShowItemClick(TObject *Sender);
    void __fastcall StartStopButtonClick(TObject *Sender);
    void __fastcall MaxSecondEditExit(TObject *Sender);
    void __fastcall MaxSecondEditKeyPress(TObject *Sender, wchar_t &Key);
    void __fastcall Timer2Timer(TObject *Sender);
    void __fastcall ExitButtonClick(TObject *Sender);
    void __fastcall MinimizeItemClick(TObject *Sender);
private:    // [U[錾
    BEGIN_MESSAGE_MAP
        // EBhETCYύX
        MESSAGE_HANDLER(WM_GETMINMAXINFO, TWMGetMinMaxInfo, WM_GetMinMaxInfo)
        // ő剻Eŏ
        MESSAGE_HANDLER(WM_SYSCOMMAND   , TWMSysCommand   , WM_SysCommand)

        // ^XNgC֘A
        MESSAGE_HANDLER(WM_MY_TASKTRAY, TMessage, TrayEvent)

        // O[oEtbN֘A
        MESSAGE_HANDLER(WM_MY_LBUTTONDOWN, TMessage, WM_LButtonDown);
        MESSAGE_HANDLER(WM_MY_MBUTTONDOWN, TMessage, WM_MButtonDown);
        MESSAGE_HANDLER(WM_MY_RBUTTONDOWN, TMessage, WM_RButtonDown);
        MESSAGE_HANDLER(WM_MY_MOUSEMOVE,   TMessage, WM_MouseMove);
        MESSAGE_HANDLER(WM_MY_KEYDOWN,     TMessage, WM_KeyDown);
    END_MESSAGE_MAP(TForm)

    static const _TCHAR APP_NAME[];

    // DLL̃CX^Xnh
    HINSTANCE m_hInst;

    // DLL֐Ăяop̊֐|C^錾
    // tbNJnĂяop
    DLLEXPORT DWORD __stdcall (*HookStart)(HWND hWnd, const _TCHAR *logFileName);
    // tbN~Ăяop
    DLLEXPORT DWORD __stdcall (*HookStop)(void);

    UnicodeString m_logFileName;

    HANDLE m_hMapping;

    bool m_isHookSet;

    bool m_firstTime;
    int m_currentTimer;
    TPoint m_cursorPos;

protected:  // [U[錾
    virtual void ScreenOff();
    virtual void WriteToIniFile();
    virtual int  StrToInt(UnicodeString s);
    virtual UnicodeString GetIniFileName() const;
    virtual UnicodeString GetLogFileName() const;

    virtual void SetHook();
    virtual void UnsetHook();

    // EBhETCYύXMp
    void __fastcall WM_GetMinMaxInfo(TWMGetMinMaxInfo &Msg);

    // ^XNgC֘A
    void __fastcall TrayEvent(TMessage& Msg);

    // ő剻Eŏ
    void __fastcall WM_SysCommand(TWMSysCommand Msg);

    // O[oEtbN֘A
    // }EX_EMp
    void __fastcall WM_LButtonDown(TMessage Msg);
    // }EX_EMp
    void __fastcall WM_MButtonDown(TMessage Msg);
    // E}EX_EMp
    void __fastcall WM_RButtonDown(TMessage Msg);
    // }EXړMp
    void __fastcall WM_MouseMove(TMessage Msg);
    // L[{[h͌op
    void __fastcall WM_KeyDown(TMessage Msg);

public:     // [U[錾
    __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif

